## tilemaker 2.0.0%2Bds

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE = 1

# Enable hardening build flags
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Obtain and set version information from debian package
include /usr/share/dpkg/pkg-info.mk
TM_VERSION := $(shell echo $(DEB_VERSION_UPSTREAM) | sed -e 's/\+.*//')

export DEB_CXXFLAGS_MAINT_APPEND=-DTM_VERSION=$(TM_VERSION)

%:
	dh $@ --buildsystem=cmake
