=== debian/changelog ===
tilemaker (2.0.0+ds-1) unstable; urgency=medium

  * Move from experimental to unstable.

 -- Felix Delattre <debian@xama.nu>  Mon, 22 Nov 2021 16:52:50 +0000

tilemaker (2.0.0+ds-1~exp1) experimental; urgency=medium

  * Initial package (Closes: #993076)

 -- Felix Delattre <debian@xama.nu>  Wed, 08 Sep 2021 14:21:21 +0000
