=== debian/control ===
Source: tilemaker
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Felix Delattre <debian@xama.nu>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 12),
               libboost-dev,
               libboost-filesystem-dev,
               libboost-iostreams-dev,
               libboost-program-options-dev,
               libboost-system-dev,
               liblua5.1-dev,
               libprotobuf-dev,
               libshp-dev,
               libsqlite3-dev,
               pkg-config,
               protobuf-compiler,
               rapidjson-dev
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/debian-gis-team/tilemaker
Vcs-Git: https://salsa.debian.org/debian-gis-team/tilemaker.git
Homepage: https://tilemaker.org/

Package: tilemaker
Section: utils
Architecture: any
Depends: shapelib,
         ${misc:Depends},
         ${shlibs:Depends},
Description: Generates vector tiles from OpenStreetMap data
 tilemaker is a single executable command that takes OpenStreetMap data as
 planet or diff files and directly makes it into vector tiles.  It's
 supremely customisable, and if you just want off-the-shelf tiles in a
 standard style, tilemaker comes bundled with the configuration and process
 files to rely on the schema of OpenMapTiles by default.
