## tilemaker 2.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -43,6 +43,9 @@
 find_package(libshp REQUIRED)
 include_directories(${LIBSHP_INCLUDE_DIR})
 
+find_package(Rapidjson REQUIRED)
+include_directories(${RAPIDJSON_INCLUDEDIR})
+
 find_package(Lua)
 
 if(LUA_FOUND)
@@ -58,10 +61,12 @@
 
 set(CMAKE_CXX_STANDARD 14)
 
-execute_process(
-	COMMAND git describe --tags --abbrev=0
-	OUTPUT_VARIABLE tm_version)
-add_compile_definitions(TM_VERSION=${tm_version})
+if(!TM_VERSION)
+	execute_process(
+		COMMAND git describe --tags --abbrev=0
+		OUTPUT_VARIABLE tm_version)
+	add_compile_definitions(TM_VERSION=${tm_version})
+endif()
 
 if(MSVC)
  	find_package(unofficial-sqlite3 CONFIG REQUIRED)
