=== Makefile ===
--- 
+++ 
@@ -1,27 +1,29 @@
 # See what Lua versions are installed
 # order of preference: LuaJIT 2.1, LuaJIT 2.0, any generic Lua, Lua 5.1
 
+PLATFORM_PATH := /usr/local
+
 ifneq ("$(wildcard /usr/local/include/luajit-2.1/lua.h)","")
   LUA_VER := LuaJIT 2.1
-  LUA_CFLAGS := -I/usr/local/include/luajit-2.1
+  LUA_CFLAGS := -I/usr/local/include/luajit-2.1 -DLUAJIT
   LUA_LIBS := -lluajit-5.1
   LUAJIT := 1
 
 else ifneq ("$(wildcard /usr/include/luajit-2.1/lua.h)","")
   LUA_VER := LuaJIT 2.1
-  LUA_CFLAGS := -I/usr/include/luajit-2.1
+  LUA_CFLAGS := -I/usr/include/luajit-2.1 -DLUAJIT
   LUA_LIBS := -lluajit-5.1
   LUAJIT := 1
 
 else ifneq ("$(wildcard /usr/local/include/luajit-2.0/lua.h)","")
   LUA_VER := LuaJIT 2.0
-  LUA_CFLAGS := -I/usr/local/include/luajit-2.0
+  LUA_CFLAGS := -I/usr/local/include/luajit-2.0 -DLUAJIT
   LUA_LIBS := -lluajit-5.1
   LUAJIT := 1
 
 else ifneq ("$(wildcard /usr/include/luajit-2.0/lua.h)","")
   LUA_VER := LuaJIT 2.0
-  LUA_CFLAGS := -I/usr/include/luajit-2.0
+  LUA_CFLAGS := -I/usr/include/luajit-2.0 -DLUAJIT
   LUA_LIBS := -lluajit-5.1
   LUAJIT := 1
 
@@ -35,6 +37,11 @@
   LUA_CFLAGS := -I/usr/include/lua
   LUA_LIBS := -llua
 
+else ifneq ("$(wildcard /usr/include/lua.h)","")
+  LUA_VER := system Lua
+  LUA_CFLAGS := -I/usr/include
+  LUA_LIBS := -llua
+
 else ifneq ("$(wildcard /usr/local/include/lua5.1/lua.h)","")
   LUA_VER := Lua 5.1
   LUA_CFLAGS := -I/usr/local/include/lua5.1
@@ -44,6 +51,12 @@
   LUA_VER := Lua 5.1
   LUA_CFLAGS := -I/usr/include/lua5.1
   LUA_LIBS := -llua5.1
+
+else ifneq ("$(wildcard /opt/homebrew/include/lua5.1/lua.h)","")
+  LUA_VER := Lua 5.1
+  LUA_CFLAGS := -I/opt/homebrew/include/lua5.1
+  LUA_LIBS := -llua5.1
+  PLATFORM_PATH := /opt/homebrew
 
 else
   $(error Couldn't find Lua)
@@ -61,10 +74,13 @@
 
 # Main includes
 
-TM_VERSION := $(shell git describe --tags --abbrev=0)
-CXXFLAGS := -O3 -Wall -Wno-unknown-pragmas -Wno-sign-compare -std=c++14 -pthread -fPIE -DTM_VERSION=$(TM_VERSION) $(CONFIG)
-LIB := -L/usr/local/lib -lz $(LUA_LIBS) -lboost_program_options -lsqlite3 -lboost_filesystem -lboost_system -lboost_iostreams -lprotobuf -lshp
-INC := -I/usr/local/include -isystem ./include -I./src $(LUA_CFLAGS)
+prefix = /usr/local
+
+MANPREFIX := /usr/share/man
+TM_VERSION ?= $(shell git describe --tags --abbrev=0)
+CXXFLAGS ?= -O3 -Wall -Wno-unknown-pragmas -Wno-sign-compare -std=c++14 -pthread -fPIE -DTM_VERSION=$(TM_VERSION) $(CONFIG)
+LIB := -L$(PLATFORM_PATH)/lib -lz $(LUA_LIBS) -lboost_program_options -lsqlite3 -lboost_filesystem -lboost_system -lboost_iostreams -lprotobuf -lshp -pthread
+INC := -I$(PLATFORM_PATH)/include -isystem ./include -I./src $(LUA_CFLAGS)
 
 # Targets
 
@@ -83,9 +99,12 @@
 	protoc --proto_path=include --cpp_out=include $<
 
 install:
-	install -m 0755 tilemaker /usr/local/bin
+	install -m 0755 -d $(DESTDIR)$(prefix)/bin/
+	install -m 0755 tilemaker $(DESTDIR)$(prefix)/bin/
+	install -d ${DESTDIR}${MANPREFIX}/man1/
+	-install docs/man/tilemaker.1 ${DESTDIR}${MANPREFIX}/man1/
 
 clean:
-	rm -f tilemaker src/*.o include/*.o
+	rm -f tilemaker src/*.o include/*.o include/*.pb.h
 
 .PHONY: install
