=== debian/changelog ===
tilemaker (2.2.0-2) unstable; urgency=medium

  * Added patch to include latomic flag when needed.

 -- Felix Delattre <debian@xama.nu>  Tue, 09 Aug 2022 16:08:02 +0000

tilemaker (2.2.0-1) unstable; urgency=medium

  [ Felix Delattre ]
  * New upstream release 2.2.0.
  * Updated patches.

  [ Bas Couwenberg ]
  * Bump Standards-Version to 4.6.1, no changes.

 -- Felix Delattre <debian@xama.nu>  Wed, 03 Aug 2022 08:20:20 +0000
