=== debian/control ===
--- 
+++ 
@@ -17,7 +17,7 @@
                pkg-config,
                protobuf-compiler,
                rapidjson-dev
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/debian-gis-team/tilemaker
 Vcs-Git: https://salsa.debian.org/debian-gis-team/tilemaker.git
 Homepage: https://tilemaker.org/
