=== debian/changelog ===
tilemaker (2.4.0-1build4) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 19:26:55 +1100

tilemaker (2.4.0-1build3) noble; urgency=high

  * No change rebuild against libprotobuf32t64.

 -- Julian Andres Klode <juliank@ubuntu.com>  Fri, 22 Mar 2024 17:57:08 +0100

tilemaker (2.4.0-1build2) noble; urgency=medium

  * Rebuild against latest shapelib

 -- Jeremy Bícha <jbicha@ubuntu.com>  Sun, 18 Feb 2024 14:43:37 -0500

tilemaker (2.4.0-1build1) noble; urgency=medium

  * No-change rebuild for boost defaults change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 19 Dec 2023 15:56:57 +0100

tilemaker (2.4.0-1) unstable; urgency=medium

  [ Bas Couwenberg ]
  * Add Rules-Requires-Root to control file.
  * Bump Standards-Version to 4.6.2, no changes.
  * Bump debhelper compat to 13.

  [ Felix Delattre ]
  * New upstream release.
  * Remove obsolete patches.
  * Updated year for copyright information.

 -- Felix Delattre <debian@xama.nu>  Sat, 01 Jul 2023 16:00:42 +0000
