=== debian/control ===
--- 
+++ 
@@ -1,10 +1,11 @@
 Source: tilemaker
-Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
 Uploaders: Felix Delattre <debian@xama.nu>
 Section: science
 Priority: optional
 Build-Depends: cmake,
-               debhelper-compat (= 12),
+               debhelper-compat (= 13),
                libboost-dev,
                libboost-filesystem-dev,
                libboost-iostreams-dev,
@@ -17,10 +18,11 @@
                pkg-config,
                protobuf-compiler,
                rapidjson-dev
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/debian-gis-team/tilemaker
 Vcs-Git: https://salsa.debian.org/debian-gis-team/tilemaker.git
 Homepage: https://tilemaker.org/
+Rules-Requires-Root: no
 
 Package: tilemaker
 Section: utils
