=== debian/changelog ===
tilemaker (3.0.0-1build1) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 11 Aug 2025 08:28:27 +0200

tilemaker (3.0.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Enable Salsa CI.
  * Replace pkg-config build dependency with pkgconf.
  * Update copyright file.
  * Update lintian overrides.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 16 Mar 2024 12:12:29 +0100
