=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: tilemaker
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
+Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
 Uploaders: Felix Delattre <debian@xama.nu>
 Section: science
 Priority: optional
@@ -15,7 +14,7 @@
                libprotobuf-dev,
                libshp-dev,
                libsqlite3-dev,
-               pkg-config,
+               pkgconf,
                protobuf-compiler,
                rapidjson-dev
 Standards-Version: 4.6.2
